&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEFINE VARIABLE FileInMemory AS MEMPTR.
DEFINE TEMP-TABLE TempData NO-UNDO
  FIELD blobData AS blob
  FIELD custnum  AS INTEGER.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS CopyTo5 FILL-IN-1 CopyCompressedTo5 ~
FILL-IN-2 ReadFrom5 FILL-IN-4 ReadCompressedFrom5 FILL-IN-3 
&Scoped-Define DISPLAYED-OBJECTS FILL-IN-1 FILL-IN-2 FILL-IN-4 FILL-IN-3 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON CopyCompressedTo5 
     LABEL "Copy Compressed Data to 5 customers" 
     SIZE 41 BY 1.14.

DEFINE BUTTON CopyTo5 
     LABEL "Copy Data to 5 customers" 
     SIZE 28 BY 1.14.

DEFINE BUTTON ReadCompressedFrom5 
     LABEL "Read Compressed Data from 5 customers" 
     SIZE 44 BY 1.14.

DEFINE BUTTON ReadFrom5 
     LABEL "Read Data from 5 customers" 
     SIZE 31 BY 1.14.

DEFINE VARIABLE FILL-IN-1 AS CHARACTER FORMAT "X(256)":U 
     LABEL "Fill 1" 
     VIEW-AS FILL-IN 
     SIZE 28 BY 1 NO-UNDO.

DEFINE VARIABLE FILL-IN-2 AS CHARACTER FORMAT "X(256)":U 
     LABEL "Fill 2" 
     VIEW-AS FILL-IN 
     SIZE 28 BY 1 NO-UNDO.

DEFINE VARIABLE FILL-IN-3 AS CHARACTER FORMAT "X(256)":U 
     LABEL "Time" 
     VIEW-AS FILL-IN 
     SIZE 28 BY 1 NO-UNDO.

DEFINE VARIABLE FILL-IN-4 AS CHARACTER FORMAT "X(256)":U 
     LABEL "Fill 1" 
     VIEW-AS FILL-IN 
     SIZE 28 BY 1 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     CopyTo5 AT ROW 1.48 COL 25 WIDGET-ID 2
     FILL-IN-1 AT ROW 2.86 COL 23 COLON-ALIGNED WIDGET-ID 6
     CopyCompressedTo5 AT ROW 4.57 COL 25 WIDGET-ID 4
     FILL-IN-2 AT ROW 6 COL 24 COLON-ALIGNED WIDGET-ID 8
     ReadFrom5 AT ROW 7.43 COL 26 WIDGET-ID 14
     FILL-IN-4 AT ROW 8.86 COL 24 COLON-ALIGNED WIDGET-ID 16
     ReadCompressedFrom5 AT ROW 10.29 COL 26 WIDGET-ID 10
     FILL-IN-3 AT ROW 11.67 COL 25 COLON-ALIGNED WIDGET-ID 12
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 80 BY 16 WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "<insert window title>"
         HEIGHT             = 16
         WIDTH              = 80
         MAX-HEIGHT         = 16
         MAX-WIDTH          = 80
         VIRTUAL-HEIGHT     = 16
         VIRTUAL-WIDTH      = 80
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME                                                           */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* <insert window title> */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE
  DO:
    /* This case occurs when the user presses the "Esc" key.
       In a persistently run window, just ignore this.  If we did not, the
       application would exit. */
    IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* <insert window title> */
DO:
    /* This event will close the window and terminate the procedure.  */
    APPLY "CLOSE":U TO THIS-PROCEDURE.
    RETURN NO-APPLY.
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CopyCompressedTo5
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CopyCompressedTo5 C-Win
ON CHOOSE OF CopyCompressedTo5 IN FRAME DEFAULT-FRAME /* Copy Compressed Data to 5 customers */
DO:
    DEFINE VARIABLE i               AS INTEGER NO-UNDO.
    DEFINE VARIABLE CompressedMem   AS MEMPTR.
    DEFINE VARIABLE uncompressedMem AS MEMPTR.
    DEFINE BUFFER bCustomer FOR Customer.
    SESSION:SET-WAIT-STATE("general").
    ETIME(TRUE).
    DO TRANSACTION i = 1 TO 5:
      FIND NEXT bCustomer WHERE bcustomer.custnum GT 50 EXCLUSIVE-LOCK.
      COPY-LOB fileInMemory TO UncompressedMem.
      CompressedMem = PUGUtils:CompressMemptr(uncompressedmem).
      COPY-LOB CompressedMem TO bCustomer.BlobField.
      set-size(CompressedMem) = 0.
    END.
    SESSION:SET-WAIT-STATE("").
    fill-in-2:screen-value = STRING(ETIME).
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CopyTo5
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CopyTo5 C-Win
ON CHOOSE OF CopyTo5 IN FRAME DEFAULT-FRAME /* Copy Data to 5 customers */
DO:
    DEFINE VARIABLE i AS INTEGER NO-UNDO.
    DEFINE BUFFER bCustomer FOR Customer.
    SESSION:SET-WAIT-STATE("general").
    ETIME(TRUE).
    DO TRANSACTION i = 1 TO 5:
      FIND NEXT bCustomer EXCLUSIVE-LOCK.
      
      COPY-LOB FileInMemory TO bCustomer.BlobField.
      
    END.  
    fill-in-1:screen-value = STRING(ETIME).
    SESSION:SET-WAIT-STATE(""). 
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME ReadCompressedFrom5
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ReadCompressedFrom5 C-Win
ON CHOOSE OF ReadCompressedFrom5 IN FRAME DEFAULT-FRAME /* Read Compressed Data from 5 customers */
DO:
    DEFINE VARIABLE i               AS INTEGER NO-UNDO.
    DEFINE VARIABLE CompressedMem   AS MEMPTR.
    DEFINE VARIABLE uncompressedMem AS MEMPTR.
    DEFINE BUFFER bCustomer FOR Customer.
    SESSION:SET-WAIT-STATE("general").
    ETIME(TRUE).
    DO i = 1 TO 5:
      FIND NEXT bCustomer WHERE bcustomer.custnum GT 50 NO-LOCK.
      
      COPY-LOB bCustomer.BlobField TO CompressedMem.
      
      UnCompressedMem = PUGUtils:DeCompressMemptr(CompressedMem).
      CREATE tempData.
      tempData.custNum = bcustomer.custnum.
      COPY-LOB unCompressedMem TO TempData.BlobData.
      
      
      set-size(UnCompressedMem) = 0.
    END.
    SESSION:SET-WAIT-STATE("").
    fill-in-3:screen-value = STRING(ETIME).
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME ReadFrom5
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ReadFrom5 C-Win
ON CHOOSE OF ReadFrom5 IN FRAME DEFAULT-FRAME /* Read Data from 5 customers */
DO:
    DEFINE VARIABLE i AS INTEGER NO-UNDO.
    DEFINE BUFFER bCustomer FOR Customer.
    SESSION:SET-WAIT-STATE("general").
    ETIME(TRUE).
    
    DO  i = 1 TO 5:
      FIND NEXT bCustomer NO-LOCK.
      CREATE tempData.
      tempdata.custnum = bcustomer.custnum.
      
      COPY-LOB bCustomer.BlobField TO tempData.BlobData.
    END.  
    fill-in-4:screen-value = STRING(ETIME).
    SESSION:SET-WAIT-STATE("").
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
  RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
  ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  /* Copy a 9mb xml file into a memptr */  
  COPY-LOB FILE ".\testload.xml" TO FileInMemory.
  
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY FILL-IN-1 FILL-IN-2 FILL-IN-4 FILL-IN-3 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE CopyTo5 FILL-IN-1 CopyCompressedTo5 FILL-IN-2 ReadFrom5 FILL-IN-4 
         ReadCompressedFrom5 FILL-IN-3 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

