
/*------------------------------------------------------------------------
    File        : HttpUtilityDemo.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Fri Feb 28 06:38:03 EST 2014
    Notes       : Needs System.Web in assemblies file
  ----------------------------------------------------------------------*/
USING System.Web.*.

DEFINE VARIABLE queryString AS CHARACTER.
DEFINE VARIABLE SomeName    AS CHARACTER.
DEFINE VARIABLE EncodedName AS CHARACTER.
DEFINE VARIABLE oNameValue  AS System.Collections.Specialized.NameValueCollection.

someName = "Smith & Wesson".
encodedName = HttpUtility:UrlEncode(SomeName).

MESSAGE 
  "Name: " someName SKIP
  "Encoded Name: " EncodedName SKIP
  "DecodedName: "HttpUtility:urlDecode (EncodedName)
  VIEW-AS ALERT-BOX.
  
someName = 'Some Name With <Brackets> and "Quotes"'.
encodedName = HttpUtility:HtmlEncode(SomeName).
MESSAGE 
  "Name: " someName SKIP
  "EncodedName: " encodedName SKIP
  "DecodedName: " HttpUtility:HtmlDecode(encodedName)
  VIEW-AS ALERT-BOX.
 
queryString = "FirstName=John&LastName=Smith&Country=Canada".  
oNameValue = HttpUtility:ParseQueryString(queryString). 
MESSAGE 
  "QueryString: " queryString SKIP
  "Value of LastName: " oNameValue["LastName"]
  VIEW-AS ALERT-BOX.

  
