
/*------------------------------------------------------------------------
    File        : ImageResizeReformat.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Thu Feb 13 14:33:17 EST 2014
    Notes       :
  ----------------------------------------------------------------------*/
USING System.IO.*.
  
DEFINE VARIABLE objImage   AS System.Drawing.Bitmap.
DEFINE VARIABLE objImage2  AS System.Drawing.Bitmap.
DEFINE VARIABLE oImageUtil AS ImageUtil.
DEFINE VARIABLE hBuff      AS HANDLE.

FIND FIRST customer EXCLUSIVE-LOCK.
hBuff = BUFFER Customer:HANDLE.

COPY-LOB FILE "penguins.bmp" TO Customer.BlobField. 

/* Initialize for demo */
Directory:Delete("c:\PugTemp",TRUE) NO-ERROR.
Directory:CreateDirectory("c:\PugTemp").

oImageUtil = NEW ImageUtil().
/* Get an image from the database without a temporary file */
objImage = oImageUtil:ImageFromBuffer(hBuff,"BlobField").

/* Save several different versions of this image */
/* Jpeg 100% quality */
oImageUtil:SaveAsJpeg("C:\PUGTemp\Penguins100.jpg",objImage,100).
/* Jpeg 50% quality */
oImageUtil:SaveAsJpeg("C:\PUGTemp\Penguins50.jpg",objImage,50).
/* Jpeg 20% quality */
oImageUtil:SaveAsJpeg("C:\PUGTemp\Penguins20.jpg",objImage,20).
/* Jpeg 200 pixel max, 50% quality */
oImageUtil:SaveAsJpeg("C:\PUGTemp\PenguinsSmall.jpg",
  oImageUtil:scaleImage(objImage,200),50). 

/* Put an image in the database without a temp file */
oImageUtil:ImageToBuffer(objImage,hBuff,"BlobField").

/* Let's put the image in the clipboard */
System.Windows.Forms.Clipboard:SetImage(objImage).
/* Capture the screen and save the resulting image to the file system */
oImageUtil:CaptureScreen():Save("c:\PUGTemp\ScreenCap.jpg").

System.Diagnostics.Process:Start("C:\PugTemp").




