
/*------------------------------------------------------------------------
    File        : Speech.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Fri Apr 22 08:33:48 EDT 2016 
    Notes       :
  ----------------------------------------------------------------------*/
USING System.Speech.Synthesis.*.
DEF VAR vText   AS LONGCHAR.
DEF VAR Speaker AS SpeechSynthesizer.
DEF VAR Voices  AS 
  "System.Collections.ObjectModel.ReadOnlyCollection<InstalledVoice>" .

Speaker = NEW SpeechSynthesizer().
Voices = Speaker:GetInstalledVoices().

{foreach.i InstalledVoice Voice in Voices}
  Speaker:SelectVoice(Voice:VoiceInfo:Name).
  Speaker:Speak(
    "Hello, my name is " + 
    Voice:VoiceInfo:Name + 
    ". Welcome to the PUG Challenge").
END.
COPY-LOB FILE "gettysburgaddress.txt" TO vText NO-CONVERT.
Speaker:Speak(vText).
