
DEFINE VARIABLE diameter AS DECIMAL                     INIT 10.
DEFINE VARIABLE leg1     AS DECIMAL                     INIT 7.
DEFINE VARIABLE leg2     AS DECIMAL                     INIT 10.
DEFINE VARIABLE hyp      AS DECIMAL.
DEFINE VARIABLE angle1   AS DECIMAL.
DEFINE VARIABLE angle2   AS DECIMAL.

FUNCTION RoundUp RETURNS DECIMAL (INPUT val AS DECIMAL, INPUT numDecimals AS INTEGER):
  DEFINE VARIABLE adjustment AS INTEGER.
  adjustment = EXP(10, numDecimals).
  RETURN System.Math:Ceiling(val * adjustment) / adjustment.  
END FUNCTION.  

MESSAGE "Volume of a sphere with a diameter of " diameter "is: " SKIP
  4 / 3 * System.Math:PI * exp(diameter / 2,3)
  VIEW-AS ALERT-BOX.
  
hyp = sqrt(EXP(leg1,2) + EXP(leg2,2)).
angle1 = System.Math:Atan (leg1 / leg2) * 180 / System.Math:PI.
angle2 = System.Math:Atan (leg2 / leg1) * 180 / System.Math:PI.

MESSAGE 
  "The length of the hypotenuse of a right triangle with legs of " leg1 " and " leg2 "Is:" SKIP
  hyp
  SKIP
  "The two angles are: " SKIP
  angle1 " Degrees"
  SKIP angle2 " Degrees"
  VIEW-AS ALERT-BOX.

MESSAGE 
  "Result of RoundUp(4.3221,0): " RoundUp(4.3221,0) SKIP
  "Result of RoundUp(4.3221,1): " RoundUp(4.3221,1) SKIP
  "Result of RoundUp(4.3221,): " RoundUp(4.3221,2) SKIP
  "Result of RoundUp(4.3221,3): " RoundUp(4.3221,3) SKIP
  VIEW-AS ALERT-BOX.
  



