
/*------------------------------------------------------------------------
    File        : WinEventLogs.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Tue May 17 10:41:31 EDT 2016
    Notes       :
  ----------------------------------------------------------------------*/
USING System.Diagnostics.Eventing.Reader.*.
DEFINE VARIABLE oQuery       AS EventLogQuery.
DEFINE VARIABLE oReader      AS EventLogReader.
DEFINE VARIABLE oEventRecord AS EventRecord.
DEFINE VARIABLE QueryString  AS CHARACTER.
DEF    VAR      oSession     AS EventLogSession.

/* 
Value: 0. Indicates logs at all levels.
Value: 1. Indicates logs for a critical alert.
Value: 2. Indicates logs for an error.
Value: 3. Indicates logs for a warning.
Value: 4. Indicates logs for an informational message.
Value: 5. Indicates logs at all levels.
*/

QueryString =
  "*[System[(Level = 3) and TimeCreated[@SystemTime >= ~'" +
  iso-date(ADD-INTERVAL(NOW,-1,"days")) + "']]]" .

oSession = NEW EventLogSession("\\wkhmrpivotsbp01").

oQuery = NEW EventLogQuery(
  "Application",
  PathType:LogName,
  QueryString ).
  
oQuery:Session = oSession.
oReader = NEW EventLogReader(oQuery).
oEventRecord = oReader:ReadEvent().
DO WHILE oEventRecord NE ?:
  MESSAGE
    oEventRecord:TimeCreated SKIP
    oEventRecord:FormatDescription()
    VIEW-AS ALERT-BOX.
  oEventRecord = oReader:ReadEvent().
END.
  
