
USING System.Net.Http.*.


/*USING System.Web.Script.Serialization.*.*/

DEFINE VARIABLE Client          AS HttpClient.
DEFINE VARIABLE ResponseJson    AS LONGCHAR.
DEFINE VARIABLE ProgressDS      AS HANDLE.
DEFINE VARIABLE hBuff           AS HANDLE.
DEFINE VARIABLE vUrl            AS CHARACTER.
DEFINE VARIABLE i               AS INTEGER.
DEFINE VARIABLE y               AS INTEGER.
DEFINE VARIABLE FieldList       AS CHARACTER.

vUrl = "http://api.worldweatheronline.com/premium/v1/weather.ashx?key=NeedTrialKeyHere&q=01821&format=json&num_of_days=5".
Client = NEW HttpClient().
/* Using Result makes this not asynchronous */
ResponseJson = Client:GetStringAsync(vUrl):Result.

/*MESSAGE string(substring(responsejson,1,500))*/
/*VIEW-AS ALERT-BOX.                           */
/* There are many ways to read Json in .Net or Progress. One of the easiest,
   if you get lucky and it works, is to read the json into a Progress
   dataset. If you use a Dynamic Dataset, you can then figure out what you
   got and then use it as you would any Progress dataset. It even adds
   recid fields for use in joins. */
CREATE DATASET ProgressDS.
ProgressDS:READ-JSON("LongChar",ResponseJson,?).

/* See what we got back */
DO y = 1 TO ProgressDS:NUM-BUFFERS:
  hBuff = ProgressDS:GET-BUFFER-HANDLE(y).
  DO i = 1 TO hBuff:NUM-FIELDS:
    fieldList = fieldList + hBuff:BUFFER-FIELD(i):Name + " - " +
      hBuff:BUFFER-FIELD(i):data-type + "~n".
  END.
  MESSAGE "Buffer Name: "
    hBuff:NAME SKIP
    hBuff:NUM-FIELDS " Fields" SKIP
    fieldList
    VIEW-AS ALERT-BOX.
  fieldList = "".
END.

hBuff = ProgressDs:GET-BUFFER-HANDLE("Current_Condition").
hBuff:FIND-FIRST().
MESSAGE 
"Time:" hBuff:BUFFER-FIELD("observation_time"):buffer-value SKIP
"TempF:" hBuff:BUFFER-FIELD("temp_f"):buffer-value SKIP
"Wind:" hBuff:BUFFER-FIELD("WindDir16Point"):buffer-value SKIP
"CloudCover:" hBuff:BUFFER-FIELD("cloudcover"):buffer-value
VIEW-AS ALERT-BOX.


   