&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */


CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS EDITOR-2 BUTTON-2 BUTTON-1 RADIO-SET-1 ~
TOGGLE-2 EDITOR-3 
&Scoped-Define DISPLAYED-OBJECTS EDITOR-2 RADIO-SET-1 TOGGLE-2 EDITOR-3 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_File 
       MENU-ITEM m_Open         LABEL "Open..."        ACCELERATOR "CTRL-O"
       MENU-ITEM m_Save         LABEL "Save..."        ACCELERATOR "CTRL-S".

DEFINE MENU MENU-BAR-C-Win MENUBAR
       SUB-MENU  m_File         LABEL "File"          .


/* Definitions of the field level widgets                               */
DEFINE BUTTON BUTTON-1 
     LABEL "Compile..." 
     SIZE 16 BY 1.19.

DEFINE BUTTON BUTTON-2 
     LABEL "Check Syntax" 
     SIZE 15 BY 1.19.

DEFINE VARIABLE EDITOR-2 AS LONGCHAR 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL LARGE
     SIZE 159 BY 22.14
     FONT 0 NO-UNDO.

DEFINE VARIABLE EDITOR-3 AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL
     SIZE 159 BY 6.67
     FONT 0 NO-UNDO.

DEFINE VARIABLE RADIO-SET-1 AS CHARACTER 
     VIEW-AS RADIO-SET HORIZONTAL
     RADIO-BUTTONS 
          "Exe", "Exe",
"Dll", "Dll"
     SIZE 19 BY .95 NO-UNDO.

DEFINE VARIABLE TOGGLE-2 AS LOGICAL INITIAL yes 
     LABEL "Run after compile?" 
     VIEW-AS TOGGLE-BOX
     SIZE 22 BY .81 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     EDITOR-2 AT ROW 1 COL 1 NO-LABEL WIDGET-ID 10
     BUTTON-2 AT ROW 23.24 COL 2.2 WIDGET-ID 16
     BUTTON-1 AT ROW 24.33 COL 57 WIDGET-ID 4
     RADIO-SET-1 AT ROW 24.57 COL 15 NO-LABEL WIDGET-ID 18
     TOGGLE-2 AT ROW 24.57 COL 35 WIDGET-ID 14
     EDITOR-3 AT ROW 25.76 COL 1 NO-LABEL WIDGET-ID 12
     "Compile As:" VIEW-AS TEXT
          SIZE 12 BY .95 AT ROW 24.57 COL 2 WIDGET-ID 22
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 159.2 BY 31.67 WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "C# Compiler"
         HEIGHT             = 31.67
         WIDTH              = 159.2
         MAX-HEIGHT         = 31.67
         MAX-WIDTH          = 159.2
         VIRTUAL-HEIGHT     = 31.67
         VIRTUAL-WIDTH      = 159.2
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-C-Win:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME                                                           */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* C# Compiler */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE 
  DO:
    /* This case occurs when the user presses the "Esc" key.
       In a persistently run window, just ignore this.  If we did not, the
       application would exit. */
    IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* C# Compiler */
DO:
    /* This event will close the window and terminate the procedure.  */
    APPLY "CLOSE":U TO THIS-PROCEDURE.
    RETURN NO-APPLY.
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BUTTON-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-1 C-Win
ON CHOOSE OF BUTTON-1 IN FRAME DEFAULT-FRAME /* Compile... */
DO:
    DEFINE VARIABLE vFilename AS CHARACTER NO-UNDO.
    DEFINE VARIABLE vOK       AS LOG       NO-UNDO.
    SYSTEM-DIALOG GET-FILE vFileName
      FILTERS 
      "Executable Files (*.exe)" "*.exe",
      "Dynamic Link Library Files (*.dll)" "*.dll",      
      "All Files (*.*)" "*.*"
      INITIAL-FILTER IF Radio-set-1:Input-value = "exe" THEN 1 ELSE 2
      DEFAULT-EXTENSION Radio-set-1:Input-value
     
      SAVE-AS
      ASK-OVERWRITE
      UPDATE vOK.
    IF NOT vOK THEN RETURN.
    RUN compileMe (vFileName).
    IF RETURN-VALUE = ""
      AND radio-set-1:input-value = "exe" THEN 
      System.Diagnostics.Process:Start(vFileName).
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BUTTON-2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-2 C-Win
ON CHOOSE OF BUTTON-2 IN FRAME DEFAULT-FRAME /* Check Syntax */
DO:
    DEFINE VARIABLE vFile AS CHARACTER.
    vFile = System.IO.Path:GetTempFileName().
    RUN CompileMe(vFile).
    IF RETURN-VALUE = "" THEN MESSAGE "Syntax OK"
        VIEW-AS ALERT-BOX.
    OS-DELETE value(vFile).
    
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME EDITOR-2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL EDITOR-2 C-Win
ON LEAVE OF EDITOR-2 IN FRAME DEFAULT-FRAME
DO:
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME



&Scoped-define SELF-NAME m_Open
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Open C-Win
ON CHOOSE OF MENU-ITEM m_Open /* Open... */
DO:
    DEFINE VARIABLE vFilename AS CHARACTER NO-UNDO.
    DEFINE VARIABLE vOK       AS LOG       NO-UNDO.
    SYSTEM-DIALOG GET-FILE vFileName
      FILTERS "C# Source Files (*.cs)" "*.cs",
      "All Files (*.*)" "*.*"
      MUST-EXIST
      UPDATE vOK.
    IF vOK THEN 
    DO WITH FRAME {&frame-name}:
      editor-2:read-file(vFileName).
    END.

  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Save
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Save C-Win
ON CHOOSE OF MENU-ITEM m_Save /* Save... */
DO:
    DEFINE VARIABLE vFilename AS CHARACTER NO-UNDO.
    DEFINE VARIABLE vOK       AS LOG       NO-UNDO.
    SYSTEM-DIALOG GET-FILE vFileName
      FILTERS "C# Source Files (*.cs)" "*.cs",
      "All Files (*.*)" "*.*"
      SAVE-AS
      ASK-OVERWRITE
      UPDATE vOK.
    IF vOK THEN 
    DO WITH FRAME {&frame-name}:
      editor-2:save-file(vFileName).
    END.
  END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
  RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
  ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CompileMe C-Win 
PROCEDURE CompileMe :
DEFINE INPUT PARAMETER pFileName AS CHARACTER.
  DEFINE VARIABLE cText    AS LONGCHAR                                   EXTENT 1.
  DEFINE VARIABLE vErrors  AS CHARACTER.
  DEFINE VARIABLE oParams  AS System.CodeDom.Compiler.CompilerParameters.
  DEFINE VARIABLE oSharp   AS Microsoft.CSharp.CSharpCodeProvider.
  DEFINE VARIABLE oResults AS System.CodeDom.Compiler.CompilerResults.
  
  oParams = NEW System.CodeDom.Compiler.CompilerParameters().
  oSharp = NEW Microsoft.CSharp.CSharpCodeProvider().
  oParams:GenerateExecutable = radio-set-1:Input-value IN FRAME {&frame-name} = "exe". 
  oParams:OutputAssembly = pFileName.
  oParams:ReferencedAssemblies:Add("System.dll").
  oParams:ReferencedAssemblies:Add("System.Core.dll").
  oParams:ReferencedAssemblies:Add("System.Drawing.dll").
  oParams:ReferencedAssemblies:Add("System.Data.DatasetExtensions.dll").
  oParams:ReferencedAssemblies:Add("System.IO.Compression.dll").
  oParams:ReferencedAssemblies:Add("System.IO.Compression.FileSystem.dll").
  oParams:ReferencedAssemblies:Add("System.Xml.dll").
  oParams:ReferencedAssemblies:Add("System.Xml.linq.dll").
        
  cText[1] = editor-2:input-value.
  oResults = oSharp:CompileAssemblyFromSource(oParams,cText).
        
  {foreach.i System.CodeDom.Compiler.CompilerError oError in oResults:Errors}
    vErrors = vErrors + "Line:" + string(oError:Line) + "  " + oError:ErrorText + "~n". 
  END.

  editor-3:screen-value = vErrors.
  IF vErrors = "" THEN RETURN.
  ELSE RETURN "Fail".

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY EDITOR-2 RADIO-SET-1 TOGGLE-2 EDITOR-3 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE EDITOR-2 BUTTON-2 BUTTON-1 RADIO-SET-1 TOGGLE-2 EDITOR-3 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

