
/*------------------------------------------------------------------------
    File        : HttpClientDemo1.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Fri Jun 05 10:51:48 EDT 2015
    Notes       :
  ----------------------------------------------------------------------*/
USING System.Net.Http.*.
USING System.Xml.*.

DEFINE VARIABLE Client       AS HttpClient.
DEFINE VARIABLE URL          AS CHARACTER.
DEFINE VARIABLE ResponseChar AS CHARACTER.
DEFINE VARIABLE Address      AS CHARACTER.
DEFINE VARIABLE xDoc         AS XmlDocument.

Address = "14 Oak Bedford ma".
URL = "http://maps.googleapis.com/maps/api/geocode/xml?sensor=false&address=".
URL = URL + address.

Client = NEW HttpClient().
/* Using Result makes this not asynchronous */
ResponseChar = Client:GetStringAsync(Url):Result.

MESSAGE SUBSTRING(ResponseChar,1,500) SKIP  
  VIEW-AS ALERT-BOX.

xDoc = NEW XmlDocument().
xDoc:LoadXml(ResponseChar).

/* Use XPath expressions to access the node values */
MESSAGE
  
  "Formatted Address: "
  xdoc:SelectSingleNode("//formatted_address"):InnerText SKIP
  "Latitude: "
  xdoc:SelectSingleNode("//location/lat"):InnerText SKIP
  "Longitude: "
  xdoc:SelectSingleNode("//location/lng"):InnerText SKIP
  VIEW-AS ALERT-BOX.

