
DEFINE VARIABLE pattern AS CHARACTER NO-UNDO.
DEFINE VARIABLE email   AS CHARACTER NO-UNDO.
DEFINE VARIABLE words   AS CHARACTER EXTENT NO-UNDO.
DEFINE VARIABLE StringToSplit AS CHARACTER NO-UNDO.

/* Replace the . with a : in Bill.Gates to show a failure */
email = "Bill.Gates@Microsoft.com".

/* This was the best pattern I found. This was found at 
    http://www.rhyous.com/2010/06/15/regular-expressions-in-cincluding-a-new-comprehensive-email-pattern/
    I changed the original pattern section that read ~{2,4~}) to ~{2,6~}) to allow for
    .museum and .travel */
Pattern =
  "^[\w!#$%&'*+\-/=?\^_`~{|~}~]+(\.[\w!#$%&'*+\-/=?\^_`~{|~}~]+)*" +
  "@"      
  + "((([\-\w]+\.)+[a-zA-Z]~{2,6~})|(([0-9]~{1,3~}\.)~{3~}[0-9]~{1,3~}))$".

MESSAGE "Valid Address?: " System.Text.RegularExpressions.Regex:IsMatch(email, pattern)
  VIEW-AS ALERT-BOX.    
  
/* Get the words out of a string */
StringToSplit = "Test-String, Has Six Words/Phrases". 
Words = System.Text.RegularExpressions.Regex:Split(StringToSplit, "\W+").  
MESSAGE 
"Extent:" EXTENT(Words) SKIP
Words[1] SKIP
Words[2] SKIP
Words[3] SKIP
Words[4] SKIP
Words[5] SKIP
Words[6] SKIP
VIEW-AS ALERT-BOX.