USING System.Net.*.
USING System.Xml.*.

DEFINE VARIABLE Client   AS WebClient.
DEFINE VARIABLE URL     AS CHARACTER.
DEFINE VARIABLE Response AS CHARACTER.
DEFINE VARIABLE Address  AS CHARACTER.
DEFINE VARIABLE xDoc     AS XmlDocument.

Address = "14 Oak Bedford ma".
URL = "http://maps.googleapis.com/maps/api/geocode/xml?sensor=false&address=".
URL = URL + address.

Client = NEW WebClient().
Response = Client:DownloadString(URL).

/* We could use any of the Progress xml capabilities, but since
   this is a .Net demo .... */
xDoc = NEW XmlDocument().
xDoc:LoadXml(Response).

/* Use XPath expressions to access the node values */
MESSAGE 
  
  "Formatted Address: " 
  xdoc:SelectSingleNode("//formatted_address"):InnerText SKIP
  "Latitude: "  
  xdoc:SelectSingleNode("//location/lat"):InnerText SKIP
  "Longitude: " 
  xdoc:SelectSingleNode("//location/lng"):InnerText SKIP
  VIEW-AS ALERT-BOX.
  

