
USING System.Diagnostics.*.
USING System.Net.*.
USING System.Web.*.

DEFINE VARIABLE Address AS CHARACTER.
DEFINE VARIABLE Client  AS WebClient.

Address = "219 littleton rd,Westford,MA".

/*vURL = "http://maps.googleapis.com/maps/api/staticmap?center=219 littleton rd,Westford,MA&zoom=16&size=600x600&sensor=false&maptype=hybrid".*/

Client = NEW WebClient().
/* This is an alternate to putting the URL as a parameter to the
   DownloadFile method. */
Client:BaseAddress = "http://maps.googleapis.com/maps/api/staticmap".
/* This is a nice way to build a query string. It can be used 
   GET requests.*/
/* If the data is character and not directly controlled by you,
   then it should be UrlEncoded in case it contains & or other 
   illegal characters on a Url. */
Client:QueryString:Add("center", HttpUtility:UrlEncode(Address)).
Client:QueryString:Add("zoom", "18").
Client:QueryString:Add("size", "600x600").
Client:QueryString:Add("sensor", "false").
Client:QueryString:Add("maptype", "hybrid").

Client:DownloadFile("", ".\map.png").

/* Now we'll open the file using the default application */
Process:Start(".\map.png").


